package tratamientoCadenas;

import java.util.StringTokenizer;

public class Cadena {

	String[] cadenaTratada = null;

	public Cadena() {
		cadenaTratada = null;
	}

	//devuelve un vector String con todos los nombres de lugares extrados de
	//nombreSinTratar, analizando caracteres los especiales "/", "(" y ")"
	public String[] obtenerNombresLugar(String nombreSinTratar) {
		StringTokenizer tk = new StringTokenizer(nombreSinTratar, "/");
		int numNombres = tk.countTokens();
		String [] nombresBarra = new String[numNombres];
		String [] nombresParentesis = new String[numNombres*2];
		
		//si hay varios nombres separados por una barra "/" los colocamos en nombresBarra
		for(int i=0; i<numNombres; i++){
			nombresBarra[i] = tk.nextToken();
		}
		
		
		//vemos si hay parntesis, en cuyo caso colocaremos como 
		//nombres posibles el nombre con y sin parntesis
		int k=0;
		for (int j=0; j<nombresBarra.length; j++, k++){
			StringTokenizer st = new StringTokenizer(nombresBarra[j], "(");
			nombresParentesis[k] = st.nextToken();
			
			//Si hay parntesis
			if (nombresBarra[j].length() != nombresParentesis[k].length()){
				k++;
				String esCapital = st.nextToken(")");
				//Si la palabra entre parntesis no es "Capital"
				if (esCapital.compareToIgnoreCase("Capital") != 0){
					nombresParentesis[k] = new String (esCapital.substring(1) + " " + nombresParentesis[k-1]);
				}
			}
		}
		
		//Todos los nombres obtenidos estn en "nombresParentesis" pero 
		//puede haber posiciones vacias
		String[] nombres = new String[k];
		for (int c=0; c<k; c++){
			//si hay comilla simple " ' " hay problemas al introducir en la BD con mysql
			//tenemos que aadir una ' para considerarla como caracter especial
			int ind = nombresParentesis[c].indexOf('\'');
			if (ind != -1){
				//si despus de ' hay espacio lo eliminamos -- por la generacion de nombres
				if (nombresParentesis[c].charAt(ind+1) == ' '){
					nombresParentesis[c] = new String (nombresParentesis[c].substring(0, ind+1) 
							+ nombresParentesis[c].substring(ind+2, nombresParentesis[c].length()-1));
				}
				nombresParentesis[c] = nombresParentesis[c].replace("'", "''");
			}
			nombres[c] = nombresParentesis[c].trim();
		}
		cadenaTratada = nombres;
		return nombres;
	}
	
	public String[] getCadenasTratadas(){
		return cadenaTratada;
	}
}
